from compgeom.pnt2d import Pnt2D

class AppModel:

    def __init__(self):
        # # Model is a simple triangle
        self.p0 = Pnt2D(100.0, 100.0)
        self.p1 = Pnt2D(200.0, 100.0)
        self.p2 = Pnt2D(150.0, 175.0)
        self.verts = [self.p0, self.p1, self.p2]
        self.edges = [[self.p0, self.p1],
                      [self.p1, self.p2],
                      [self.p2, self.p0]]
        self.faces = [[self.p0, self.p1, self.p2]]
        # Model is a concave polygon
        # self.p0 = Pnt2D(100.0, 100.0)
        # self.p1 = Pnt2D(200.0, 100.0)
        # self.p2 = Pnt2D(200.0, 200.0)
        # self.p3 = Pnt2D(175.0, 200.0)
        # self.p4 = Pnt2D(175.0, 150.0)
        # self.p5 = Pnt2D(125.0, 150.0)
        # self.p6 = Pnt2D(125.0, 200.0)
        # self.p7 = Pnt2D(100.0, 200.0)
        # self.verts = [self.p0, self.p1, self.p2, self.p3, self.p4, self.p5, self.p6, self.p7]
        # self.edges = [[self.p0, self.p1],
        #               [self.p1, self.p2],
        #               [self.p2, self.p3],
        #               [self.p3, self.p4],
        #               [self.p4, self.p5],
        #               [self.p5, self.p6],
        #               [self.p6, self.p7],
        #               [self.p7, self.p0]]
        # self.faces = [[self.p0, self.p1, self.p2, self.p3, self.p4, self.p5, self.p6, self.p7]]

    def isEmpty(self):
        return self.verts == None

    def getVerts(self):
        return self.verts

    def getEdges(self):
        return self.edges

    def getFaces(self):
        return self.faces

    def getVertexPt(self, _vertex):
        return _vertex

    def getEdgePtsToDraw(self, _edge):
        return _edge

    def getFacePtsToDraw(self, _face):
        return _face
